void ConnectToCOMPort()
{
  try {
    myPort.stop();
  }
  catch(Exception e) { }
  
String portName = Serial.list()[COMPortDD.SelStr];
println(portName);
try {
myPort = new Serial(this, portName, 9600);
button2.setText("Connected");
}
catch(Exception e)
{
  button2.setText("Try Again");
}
}//end func

void Button1Func()   //send all configurations
{
  //need to build up the data that will be sent
  //Data Mode - DMX Address Lo - DMX Address Hi - User Pixel Amount Lo - User Pixel Amount Hi -User Serial Baud - Flags MSB LED Enabled
int[] DataArray = new int[8];

//0= 2801, 1= 2803, 2= 2811, 3=2812, 4=2812B, 5=LDP8806, 6=LPD6803
if(dropList1.getSelectedIndex() == 0 || dropList1.getSelectedIndex() == 1) DataArray[0] = 2; //Firmware ID for standard SPI devices is 2
else if(dropList1.getSelectedIndex() == 2 || dropList1.getSelectedIndex() == 3 || dropList1.getSelectedIndex() == 4) DataArray[0] = 0; //Firmware ID for 800KHz World Semi Pixels is 0
else if(dropList1.getSelectedIndex() == 5) DataArray[0] = 4; //Firmware ID for standard SPI devices is 2
else if(dropList1.getSelectedIndex() == 6) DataArray[0] = 6; //LPD6803
else if(dropList1.getSelectedIndex() == 7) DataArray[0] = 8; //APA102
//DMX Address 
DataArray[1] = (int(textfield1.getText()) & 0xFF); //LSB
DataArray[2] = ((int(textfield1.getText()) >> 8) & 0xFF); //MSB
//DMX Pixel Amount
DataArray[3] = (int(textfield2.getText()) & 0xFF); //LSB
DataArray[4] =((int(textfield2.getText()) >> 8) & 0xFF); //MSB

//Baud Rate
if(checkbox1.isSelected())  {
  //use TextField for custom SPBRG value if box is checked
DataArray[5] = 0; //indicates to use the custom value in DataArray[8]
DataArray[6] =  (int(textfield3.getText()));
println(textfield3.getText()+" Loaded Custom SPBRG value "+parseInt(textfield3.getText()));
}
else { //else use drop down and SPBRG values for 32mhz PIC processors with BRG16 set
DataArray[5] = dropList2.getSelectedIndex()+1; //SPBRGValues[dropList2.getSelectedIndex()];
DataArray[6] = 0; //not used so leave it 0
println("User Baud: "+DataArray[7]);
}
 
if(checkbox2.isSelected()) DataArray[7] = 0; //binary 00000000
else DataArray[7] = 128; //binary 10000000 //Enable LED for RX

println(DataArray);
//when sending bytes one at a time they are technically send in seperate USB packets
//   so there is a delay of a few mS between them, though the device could have them sent all
//    back to back and still recieve correctly.
myPort.write(123); //just some random numbers chosen that have to arrive first or 
myPort.write(253);  // the firmware won't allow a write, to hopefully prevent accidental confiurations
myPort.write(82);
myPort.write(7);  
//end frame bytes
myPort.write(DataArray[0]); //DataMode
myPort.write(DataArray[1]); //DMX Adr Lo
myPort.write(DataArray[2]); //DMX Adr Hi
myPort.write(DataArray[3]);//Pixel Amount DMX, Lo
myPort.write(DataArray[4]);//Pixel Amount DMX, Hi
myPort.write(DataArray[5]); //UserBaud ID, 0 means use custom SPBRG value
myPort.write(DataArray[6]); //custom SPBRG value, can be any value if not used
myPort.write(slider1.getValueI()); //PR2 Value
myPort.write(DataArray[7]); //flags, currently only holding enable RX LED
} //end func

void mousePressed()
{
  if(mouseButton == RIGHT) return;
  
  if (COMPortDD.over())// && FrameOptionsDD.Selected == false)
  {
    if (COMPortDD.Selected  == true) COMPortDD.Selected = false;
    else COMPortDD.Selected = true;  
    println("Pressed DropDown Open");
  }
  else if (COMPortDD.overOpen() != 0 && COMPortDD.Selected == true)
  {
    println("Pressed DropDown "+COMPortDD.overOpen() );
    COMPortDD.Selected = false;
    COMPortDD.SelStr = (COMPortDD.overOpen()-1);
  } //end else
} //end mousePressed()
